function []=favouritedirs(action,path)
  [lhs,rhs]=argn();
  favlist=[];
  favoritsgui_workpath=home + filesep();
  filename=favoritsgui_workpath+'.scilab.favouritedirs.txt';
  [x,err]=fileinfo(filename);
  favlist=[];

  if (err==0) then
    favlist=mgetl(filename);
  end
  if rhs <=0 then // select favorite directorie
    if (favlist==[]) then
      favlist=['No favourites!'];
    end
    x=x_choose(favlist,'Favourites: Change to directory');
    if x>0 then
      chdir(favlist(x));
      disp('Changed current directory to: '+pwd());
    end
  end

  if (rhs==1) & (typeof(action)=='constant') then // initialize all needed functions
    if action==1 then
		printf('\n');
		printf('========================================\n');
		printf('README\n');
		printf('Favourite Directories for Scilab   15.08\n');
		printf('========================================\n');
		printf('author: Dipl.-Ing. Klaus Weichinger\n');
		printf('email:  snaky.1@gmx.at\n');
		printf('web:    bioe.sourceforge.net\n');
		printf('\n');
		printf('1. Function\n');
		printf('------------------\n');
		printf('  This module provides an additional menu item\n');
		printf('  in scilab, where the user can add and remove\n');
		printf('  frequently used directories.\n');
		printf('  \n');
		printf('  The current working directory can be\n');
		printf('  added to the list or changed with a mouse click.\n');
		printf('  Press ENTER within the scilab-console to trigger\n');
		printf('  a File-Browser refresh within scilab.\n');
		printf('\n');
		printf('  On Windows OS the command ""explorer();"" opens the\n');
		printf('  explorer window with the current working directory.\n');
		printf('\n');
		printf('2. Dedication\n');
		printf('------------------\n');
		printf('  This small piece of code was developed before year\n');
		printf('  2012 and now i publish and dedicate it our beloved\n');
		printf('  son Gregor, who died suddenly 2015.\n');
		printf('\n');
		printf('     +-----+     \n');
		printf('     |      \\    # \n');
		printf('     |Gregor +---#--+\n');
		printf('    _|___ Weichinger \\\n');
		printf('   /     \\  2012-2015 |\n');
		printf('  |   O   |----/   \\--+\n');
		printf('   \\     /     \\   /\n');
		printf('  ###############################\n');
		printf('\n');
		printf('\n');
		printf('3. Licensing\n');
		printf('------------------\n');
		printf('  The software of this project is distributed under\n');
		printf('  the terms and conditions of the\n');
		printf('  GNU GENERAL PUBLIC LICENSE Version 3, 29 June 2007.\n');
		printf('  \n');
		printf('  The full text version of the license is attached\n');
		printf('  within the license.txt file.\n');
      
    end
    if action==2 then
      favouritedirs();
    end
    if action==3 then
      favouritedirs('addcurrent');
    end
    if action==4 then
      favouritedirs('del');
    end
    if action>5 then
      favouritedirs('change',favlist(action-5));
    end
  end

  
  if (rhs==1) & (typeof(action)=='string') & (action=='start') then // initialize all needed functions
    addmenu('Favourite Directories');
    favouritedirs('refreshmenu');
  end
  if (rhs==1) & (typeof(action)=='string') & (action=='quit') then
    delmenu('Favourite Directories');
  end
  if (rhs==1) & (typeof(action)=='string') & (action=='refreshmenu') then
    favmen=['Readme','List favourite directories','Add current working-directory to favourites','Remove from favourites','---------'];
    for i=1:max(size(favlist))
      favmen=[favmen,favlist(i)];
    end
    delmenu('Favourite Directories');
    addmenu('Favourite Directories',favmen,list(2,'favouritedirs'));
  end
  if (rhs==1) & (typeof(action)=='string') & (action=='del') then // delete directory
    if (favlist==[]) then
      favlist=['No favourites!'];
    end
    x=x_choose(favlist,'Favourites: Remove directory');
    if x>0 then
      r=messagebox("You realy want to remove that directory from the favouritelist?", "modal", "passwd", ["Yes" "No"]); 
      if (r==1) then
        len=max(size(favlist));
        disp('Removing from favourites: '+favlist(x));
        favlist=[favlist(1:x-1);favlist(x+1:len)];
        fd=mopen(filename,'wt');
        if (max(size(favlist))==0) then
        else
          mputl(favlist,fd);
        end
        mclose(fd);
        favouritedirs('refreshmenu');        
      end
    end
  end
  if (rhs==1) & (typeof(action)=='string') & (action=='addcurrent') then // add pwd() to favorites
    favlist=[pwd();favlist];
    mputl(favlist,filename);
    disp('Current directory added  to favourites!');
    favouritedirs('refreshmenu');    
  end
  if (rhs==2) & (typeof(action)=='string') & (action=='change') then
      chdir(path);
      disp('Changed current directory to: '+pwd());
  end
  if (rhs==2) & (typeof(action)=='string') & (action=='add') then // add passed path to favorites
    favlist=[path;favlist];
    mputl(favlist,filename);
    disp('Added to favourites!');
    favouritedirs('refreshmenu');
  end
endfunction


function explorer
  [OS]=getos();
  if (OS=='Windows') then
    host('explorer.exe /e,'+pwd());
  end
endfunction
